# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['AwsExternalIdArgs', 'AwsExternalId']

@pulumi.input_type
class AwsExternalIdArgs:
    def __init__(__self__):
        """
        The set of arguments for constructing a AwsExternalId resource.
        """
        pass


@pulumi.input_type
class _AwsExternalIdState:
    def __init__(__self__, *,
                 external_id: Optional[pulumi.Input[builtins.str]] = None,
                 tailscale_aws_account_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering AwsExternalId resources.
        :param pulumi.Input[builtins.str] external_id: The External ID that Tailscale will supply when assuming your role. You must reference this in your IAM role's trust policy. See https://docs.aws.amazon.com/IAM/latest/UserGuide/id*roles*common-scenarios_third-party.html for more information on external IDs.
        :param pulumi.Input[builtins.str] tailscale_aws_account_id: The AWS account from which Tailscale will assume your role. You must reference this in your IAM role's trust policy. See https://docs.aws.amazon.com/IAM/latest/UserGuide/id*roles*common-scenarios_third-party.html for more information on external IDs.
        """
        if external_id is not None:
            pulumi.set(__self__, "external_id", external_id)
        if tailscale_aws_account_id is not None:
            pulumi.set(__self__, "tailscale_aws_account_id", tailscale_aws_account_id)

    @property
    @pulumi.getter(name="externalId")
    def external_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The External ID that Tailscale will supply when assuming your role. You must reference this in your IAM role's trust policy. See https://docs.aws.amazon.com/IAM/latest/UserGuide/id*roles*common-scenarios_third-party.html for more information on external IDs.
        """
        return pulumi.get(self, "external_id")

    @external_id.setter
    def external_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "external_id", value)

    @property
    @pulumi.getter(name="tailscaleAwsAccountId")
    def tailscale_aws_account_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The AWS account from which Tailscale will assume your role. You must reference this in your IAM role's trust policy. See https://docs.aws.amazon.com/IAM/latest/UserGuide/id*roles*common-scenarios_third-party.html for more information on external IDs.
        """
        return pulumi.get(self, "tailscale_aws_account_id")

    @tailscale_aws_account_id.setter
    def tailscale_aws_account_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "tailscale_aws_account_id", value)


@pulumi.type_token("tailscale:index/awsExternalId:AwsExternalId")
class AwsExternalId(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 __props__=None):
        """
        The aws_external_id resource allows you to mint an AWS External ID that Tailscale can use to assume an AWS IAM role that you create for the purposes of allowing Tailscale to stream logs to your S3 bucket. See the logstream_configuration resource for more details.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[AwsExternalIdArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The aws_external_id resource allows you to mint an AWS External ID that Tailscale can use to assume an AWS IAM role that you create for the purposes of allowing Tailscale to stream logs to your S3 bucket. See the logstream_configuration resource for more details.

        :param str resource_name: The name of the resource.
        :param AwsExternalIdArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AwsExternalIdArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AwsExternalIdArgs.__new__(AwsExternalIdArgs)

            __props__.__dict__["external_id"] = None
            __props__.__dict__["tailscale_aws_account_id"] = None
        super(AwsExternalId, __self__).__init__(
            'tailscale:index/awsExternalId:AwsExternalId',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            external_id: Optional[pulumi.Input[builtins.str]] = None,
            tailscale_aws_account_id: Optional[pulumi.Input[builtins.str]] = None) -> 'AwsExternalId':
        """
        Get an existing AwsExternalId resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] external_id: The External ID that Tailscale will supply when assuming your role. You must reference this in your IAM role's trust policy. See https://docs.aws.amazon.com/IAM/latest/UserGuide/id*roles*common-scenarios_third-party.html for more information on external IDs.
        :param pulumi.Input[builtins.str] tailscale_aws_account_id: The AWS account from which Tailscale will assume your role. You must reference this in your IAM role's trust policy. See https://docs.aws.amazon.com/IAM/latest/UserGuide/id*roles*common-scenarios_third-party.html for more information on external IDs.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AwsExternalIdState.__new__(_AwsExternalIdState)

        __props__.__dict__["external_id"] = external_id
        __props__.__dict__["tailscale_aws_account_id"] = tailscale_aws_account_id
        return AwsExternalId(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="externalId")
    def external_id(self) -> pulumi.Output[builtins.str]:
        """
        The External ID that Tailscale will supply when assuming your role. You must reference this in your IAM role's trust policy. See https://docs.aws.amazon.com/IAM/latest/UserGuide/id*roles*common-scenarios_third-party.html for more information on external IDs.
        """
        return pulumi.get(self, "external_id")

    @property
    @pulumi.getter(name="tailscaleAwsAccountId")
    def tailscale_aws_account_id(self) -> pulumi.Output[builtins.str]:
        """
        The AWS account from which Tailscale will assume your role. You must reference this in your IAM role's trust policy. See https://docs.aws.amazon.com/IAM/latest/UserGuide/id*roles*common-scenarios_third-party.html for more information on external IDs.
        """
        return pulumi.get(self, "tailscale_aws_account_id")

