# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['DnsSplitNameserversArgs', 'DnsSplitNameservers']

@pulumi.input_type
class DnsSplitNameserversArgs:
    def __init__(__self__, *,
                 domain: pulumi.Input[builtins.str],
                 nameservers: pulumi.Input[Sequence[pulumi.Input[builtins.str]]]):
        """
        The set of arguments for constructing a DnsSplitNameservers resource.
        :param pulumi.Input[builtins.str] domain: Domain to configure split DNS for. Requests for this domain will be resolved using the provided nameservers. Changing this will force the resource to be recreated.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] nameservers: Devices on your network will use these nameservers to resolve DNS names. IPv4 or IPv6 addresses are accepted.
        """
        pulumi.set(__self__, "domain", domain)
        pulumi.set(__self__, "nameservers", nameservers)

    @property
    @pulumi.getter
    def domain(self) -> pulumi.Input[builtins.str]:
        """
        Domain to configure split DNS for. Requests for this domain will be resolved using the provided nameservers. Changing this will force the resource to be recreated.
        """
        return pulumi.get(self, "domain")

    @domain.setter
    def domain(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "domain", value)

    @property
    @pulumi.getter
    def nameservers(self) -> pulumi.Input[Sequence[pulumi.Input[builtins.str]]]:
        """
        Devices on your network will use these nameservers to resolve DNS names. IPv4 or IPv6 addresses are accepted.
        """
        return pulumi.get(self, "nameservers")

    @nameservers.setter
    def nameservers(self, value: pulumi.Input[Sequence[pulumi.Input[builtins.str]]]):
        pulumi.set(self, "nameservers", value)


@pulumi.input_type
class _DnsSplitNameserversState:
    def __init__(__self__, *,
                 domain: Optional[pulumi.Input[builtins.str]] = None,
                 nameservers: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None):
        """
        Input properties used for looking up and filtering DnsSplitNameservers resources.
        :param pulumi.Input[builtins.str] domain: Domain to configure split DNS for. Requests for this domain will be resolved using the provided nameservers. Changing this will force the resource to be recreated.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] nameservers: Devices on your network will use these nameservers to resolve DNS names. IPv4 or IPv6 addresses are accepted.
        """
        if domain is not None:
            pulumi.set(__self__, "domain", domain)
        if nameservers is not None:
            pulumi.set(__self__, "nameservers", nameservers)

    @property
    @pulumi.getter
    def domain(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Domain to configure split DNS for. Requests for this domain will be resolved using the provided nameservers. Changing this will force the resource to be recreated.
        """
        return pulumi.get(self, "domain")

    @domain.setter
    def domain(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "domain", value)

    @property
    @pulumi.getter
    def nameservers(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        Devices on your network will use these nameservers to resolve DNS names. IPv4 or IPv6 addresses are accepted.
        """
        return pulumi.get(self, "nameservers")

    @nameservers.setter
    def nameservers(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "nameservers", value)


@pulumi.type_token("tailscale:index/dnsSplitNameservers:DnsSplitNameservers")
class DnsSplitNameservers(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 domain: Optional[pulumi.Input[builtins.str]] = None,
                 nameservers: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        """
        The dns_split_nameservers resource allows you to configure split DNS nameservers for your Tailscale network. See https://tailscale.com/kb/1054/dns for more information.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tailscale as tailscale

        sample_split_nameservers = tailscale.DnsSplitNameservers("sample_split_nameservers",
            domain="foo.example.com",
            nameservers=["1.1.1.1"])
        ```

        ## Import

        Split DNS nameservers can be imported using the domain name, e.g.

        ```sh
        $ pulumi import tailscale:index/dnsSplitNameservers:DnsSplitNameservers sample_split_nameservers example.com
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] domain: Domain to configure split DNS for. Requests for this domain will be resolved using the provided nameservers. Changing this will force the resource to be recreated.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] nameservers: Devices on your network will use these nameservers to resolve DNS names. IPv4 or IPv6 addresses are accepted.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DnsSplitNameserversArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The dns_split_nameservers resource allows you to configure split DNS nameservers for your Tailscale network. See https://tailscale.com/kb/1054/dns for more information.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_tailscale as tailscale

        sample_split_nameservers = tailscale.DnsSplitNameservers("sample_split_nameservers",
            domain="foo.example.com",
            nameservers=["1.1.1.1"])
        ```

        ## Import

        Split DNS nameservers can be imported using the domain name, e.g.

        ```sh
        $ pulumi import tailscale:index/dnsSplitNameservers:DnsSplitNameservers sample_split_nameservers example.com
        ```

        :param str resource_name: The name of the resource.
        :param DnsSplitNameserversArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DnsSplitNameserversArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 domain: Optional[pulumi.Input[builtins.str]] = None,
                 nameservers: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DnsSplitNameserversArgs.__new__(DnsSplitNameserversArgs)

            if domain is None and not opts.urn:
                raise TypeError("Missing required property 'domain'")
            __props__.__dict__["domain"] = domain
            if nameservers is None and not opts.urn:
                raise TypeError("Missing required property 'nameservers'")
            __props__.__dict__["nameservers"] = nameservers
        super(DnsSplitNameservers, __self__).__init__(
            'tailscale:index/dnsSplitNameservers:DnsSplitNameservers',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            domain: Optional[pulumi.Input[builtins.str]] = None,
            nameservers: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None) -> 'DnsSplitNameservers':
        """
        Get an existing DnsSplitNameservers resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] domain: Domain to configure split DNS for. Requests for this domain will be resolved using the provided nameservers. Changing this will force the resource to be recreated.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] nameservers: Devices on your network will use these nameservers to resolve DNS names. IPv4 or IPv6 addresses are accepted.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DnsSplitNameserversState.__new__(_DnsSplitNameserversState)

        __props__.__dict__["domain"] = domain
        __props__.__dict__["nameservers"] = nameservers
        return DnsSplitNameservers(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def domain(self) -> pulumi.Output[builtins.str]:
        """
        Domain to configure split DNS for. Requests for this domain will be resolved using the provided nameservers. Changing this will force the resource to be recreated.
        """
        return pulumi.get(self, "domain")

    @property
    @pulumi.getter
    def nameservers(self) -> pulumi.Output[Sequence[builtins.str]]:
        """
        Devices on your network will use these nameservers to resolve DNS names. IPv4 or IPv6 addresses are accepted.
        """
        return pulumi.get(self, "nameservers")

